import { GetRequest } from './get.request';
import { ApiService } from '../services/api.service';
import { ApiEntity } from '../interfaces/api-entity';
import { SearchParams } from '../interfaces/search-params';
import { ApiResponse } from '../interfaces/api-response';
import { ApiPagination } from '../interfaces/api-pagination';
export declare class ApiSearchRequest<T extends ApiEntity> extends GetRequest<T> {
    protected service: ApiService<T>;
    protected queryParams: SearchParams;
    constructor(service: ApiService<T>, queryParams: SearchParams);
    query(value: string): this;
    page(value: number): this;
    perPage(value: number): this;
    filterBy(field: string, value: any): this;
    orderBy(field: string, isDescending?: boolean): this;
    all(value?: boolean): this;
    with(value: string[]): this;
    execute<Y>(): Promise<ApiResponse<ApiPagination<Y extends ApiEntity ? T[] : Y[]>>>;
}
