import { ApiService } from '../services/api.service';
import { ApiEntity } from '../interfaces/api-entity';
import { UrlParams } from '../interfaces/url-params';
export declare abstract class GetRequest<T extends ApiEntity> {
    protected service: ApiService<T>;
    protected queryParams: any;
    protected urlParams: UrlParams;
    constructor(service: ApiService<T>, queryParams: any);
    url(urlParams: UrlParams): this;
    /**
     * Implementation of the adding `with_trashed` into request
     *
     * @param {boolean} value
     */
    withTrashed(value?: boolean): this;
    /**
     * Implementation of the request execution at the service
     */
    abstract execute<Y>(): any;
    abstract execute(): any;
}
