import { ApiService } from '../services/api.service';
import { ApiEntity } from '../interfaces/api-entity';
import { UrlParams } from '../interfaces/url-params';
export declare abstract class PostRequest<T extends ApiEntity> {
    protected service: ApiService<T>;
    protected entity: Partial<T>;
    protected urlParams: UrlParams;
    constructor(service: ApiService<T>, entity: Partial<T>);
    url(urlParams: UrlParams): this;
    data(data: Partial<T>): this;
    filter(filter: ((data: any) => T) | string[]): this;
    /**
     * Implementation of the request execution at the service
     */
    abstract execute<Y>(): any;
    abstract execute(): any;
}
